"use strict";

var _createActionCreator = require("./createActionCreator");

var _createActionCreator2 = _interopRequireDefault(_createActionCreator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("create reducer", function () {
  it("simple action", function () {
    expect((0, _createActionCreator2.default)("A")("test")).toEqual({ type: "A", payload: "test" });
  });

  it("simple action containing object", function () {
    expect((0, _createActionCreator2.default)("A")({ test: "test" })).toEqual({ type: "A", payload: { test: "test" } });
  });

  it("simple action joining two types", function () {
    expect((0, _createActionCreator2.default)("A", "B")(true)).toEqual({ type: "A_B", payload: true });
  });

  it("simple action joining two types", function () {
    expect((0, _createActionCreator2.default)(["A", "B"])(true)).toEqual({ type: "A_B", payload: true });
  });
});