"use strict";

var _asyncActionType = require("./asyncActionType");

var _asyncActionType2 = _interopRequireDefault(_asyncActionType);

var _createAsyncActionCreator = require("./createAsyncActionCreator");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("create async action creator", function () {
  describe("call with simple text", function () {
    it("request action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH_PRODUCT").request({
        id: 1
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.REQUEST,
        payload: { id: 1 }
      });
    });

    it("success action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH_PRODUCT").success({
        id: 1,
        name: "Product 1"
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.SUCCESS,
        payload: { id: 1, name: "Product 1" }
      });
    });

    it("failure action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH_PRODUCT").failure({
        error: {
          message: "something went wrong"
        }
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.FAILURE,
        payload: {
          error: {
            message: "something went wrong"
          }
        }
      });
    });
  });

  describe("call with multiple strings", function () {
    it("request action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH", "PRODUCT").request({
        id: 1
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.REQUEST,
        payload: { id: 1 }
      });
    });

    it("success action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH", "PRODUCT").success({
        id: 1,
        name: "Product 1"
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.SUCCESS,
        payload: { id: 1, name: "Product 1" }
      });
    });

    it("failure action", function () {
      expect((0, _createAsyncActionCreator.createAsyncActionCreator)("FETCH", "PRODUCT").failure({
        error: {
          message: "something went wrong"
        }
      })).toEqual({
        type: "FETCH_PRODUCT_" + _asyncActionType2.default.FAILURE,
        payload: {
          error: {
            message: "something went wrong"
          }
        }
      });
    });
  });
});