"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _lodash = require("lodash");

var _createActionType = require("./createActionType");

var _createActionType2 = _interopRequireDefault(_createActionType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var createReducer = function createReducer(defaultState, reducerMap) {
  var iterator = function iterator(reducers) {
    var initial = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var prefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    return (0, _lodash.reduce)(reducers, function (acc, reducer, type) {
      if ((0, _lodash.isFunction)(reducer)) {
        return _extends({}, acc, _defineProperty({}, (0, _createActionType2.default)(prefix, type), reducer));
      }

      if (!(0, _lodash.isObject)(reducer)) {
        throw "createReducer expect 'Object' tree with 'Leafs' (A node with no children) containing function that takes arguments (state, action)";
      }

      return iterator(reducer, acc, [(0, _createActionType2.default)(prefix, type)]);
    }, initial);
  };

  var flattened = iterator(reducerMap);

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
    var action = arguments[1];

    if (!flattened.hasOwnProperty(action.type)) {
      return state;
    }

    var reducer = flattened[action.type];

    return reducer(state, action.payload);
  };
};

exports.default = createReducer;